/*
	TuxPuck - aiplayers.h
	Copyright (C) 2001 Jacob Kroon

	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

	Jacob Kroon - d00jkr@efd.lth.se
*/

#ifndef _AIPLAYERS_H
#define _AIPLAYERS_H

class TuxPlayer;
class CartmanPlayer;
class HomerPlayer;

/* includes */
#ifndef _PLAYER_H
#include "player.h"
#endif
#ifndef _SPRITE_H
#include "sprite.h"
#endif
#ifndef _AUDIO_H
#include "audio.h"
#endif

/* class */
class TuxPlayer:public AIPlayer
{
private:
  SDL_Surface * _sdlTux;
  Sprite *_sprEyes;
  Sound *_sndApps, *_sndBoos;
public:
    TuxPlayer(Pad *, Puck *);
   ~TuxPlayer();
  void setState(Uint8);
  Uint8 reblit(Uint32);
  void blit(void);
};

class CartmanPlayer:public AIPlayer
{
private:
  SDL_Surface * _sdlCartman;
  Sprite *_sprEyes, *_sprMouth;
  Sound *_sndKickAss, *_sndSoab;
public:
    CartmanPlayer(Pad *, Puck *);
   ~CartmanPlayer();
  void setState(Uint8);
  Uint8 reblit(Uint32);
  void blit(void);
};

class HomerPlayer:public AIPlayer
{
private:
  SDL_Surface * _sdlHomer;
  Sound *_sndDoh, *_sndWoohoo;
  Sprite *_sprEyes, *_sprMouth;
public:
    HomerPlayer(Pad *, Puck *);
   ~HomerPlayer();
  void setState(Uint8);
  Uint8 reblit(Uint32);
  void blit(void);
};

#endif /* _AIPLAYERS_H */
