/*
	TuxPuck - audio.h
	Copyright (C) 2001 Jacob Kroon

	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

	Jacob Kroon - d00jkr@efd.lth.se
*/

#ifndef _AUDIO_H
#define _AUDIO_H

class Audio;
struct Sound;
struct SoundNode;

/* includes */
#ifndef _SDL_audio_h
#include <SDL_audio.h>
#endif

/* structs */
struct Sound
{
  Uint32 length, single;
  Uint8 *buffer;
};

struct SoundNode
{
  Uint32 position;
  Sound *sound;
  SoundNode *next;
};

/* class */
class Audio
{
private:
  static Audio *_instance;
  static Uint8 _mute;
  static SoundNode *_soundNode;
  Uint8 _initiated;
  SDL_AudioSpec _spec;
    Audio();
  static void _mixAudio(void *, Uint8 *, int);
public:
   ~Audio();
  void playSound(Sound *);
  Sound *createSound(Uint8 *, Uint32 *);
  void freeSound(Sound *);
  void setMute(Uint8);
  static Audio *instance(void);
};

#endif /* _AUDIO_H */
