/*
	TuxPuck - board.h
	Copyright (C) 2001 Jacob Kroon

	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

	Jacob Kroon - d00jkr@efd.lth.se
*/

#ifndef _BOARD_H
#define _BOARD_H

class Board;

/* includes */
#ifndef _BOARDENTITY_H
#include "boardentity.h"
#endif
#ifndef _GLASS_H
#include "glass.h"
#endif

/* defines */
#define A1      ((float)465)
#define A2      ((float)175)
#define W1      ((float)203)
#define W2      ((float)517)

/* class */
class Board
{
private:
  SDL_Surface * _sdlBoard;
  Uint8 _state;
  float _coeff[4];
  Pad *_pad_1, *_pad_2;
  Puck *_thePuck;
  Glass *_theGlass;
  Uint8 _getScorer(void);
public:
    Board();
   ~Board();
  Uint8 update(Uint32);
  void reblit(void);
  void erase(void);
  void blit(void);
  Pad *getPad(Uint8);
  Puck *getPuck(void);
  float calcY(float);
  float calcScale(float);
};

#endif /* _BOARD_H */
