/*
	TuxPuck - font.h
	Copyright (C) 2001 Jacob Kroon

	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

	Jacob Kroon - d00jkr@efd.lth.se
*/

#ifndef _FONT_H
#define _FONT_H

class Font;
struct Glyph;

/* includes */
#ifndef _SDL_video_h
#include <SDL_video.h>
#endif

/* structs */
struct Glyph
{
  Sint16 xMove, yMove, advance;
  SDL_Surface *bitmap;
};

/* class */
class Font
{
private:
  Glyph ** _glyph;
  Uint16 _x, _y;
public:
    Font(Uint8 *, Uint32 *);
   ~Font();
  void print(char *, SDL_Rect *);
  Uint32 calcWidth(char *);
  void setPen(Uint16, Uint16);
  void movePen(Uint16, Uint16);
  void setColor(Uint8, Uint8, Uint8);
};

#endif /* _FONT_H */
