/*
	TuxPuck - glass.h
	Copyright (C) 2001 Jacob Kroon

	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

	Jacob Kroon - d00jkr@efd.lth.se
*/

#ifndef _GLASS_H
#define _GLASS_H

class Glass;
class GlassPiece;

/* includes */
#ifndef _BOARDENTITY_H
#include "boardentity.h"
#endif
#ifndef _AUDIO_H
#include "audio.h"
#endif
#ifndef _BOARD_H
#include "board.h"
#endif

/* classes */
class GlassPiece
{
private:
  Board * _theBoard;
  float _x, _y, _z, _dx, _dy;
  Uint32 _id;
  SDL_Surface *_sdlImage;
  Glass *_theGlass;
  SDL_Rect _oldRect;
public:
    GlassPiece(Board *, Glass *, Uint32);
   ~GlassPiece();
  void reset(void);
  void blit(void);
  void erase(void);
  Uint8 update(Uint32);
};

class Glass
{
private:
  Board * _theBoard;
  float _x, _z;
  SDL_Surface *_sdlGlass;
  GlassPiece *_piece[5];
  SDL_Rect _oldRect;
  Sound *_sndCrash;
public:
    Glass(Board *);
   ~Glass();
  Uint8 update(Uint32);
  void smash(Puck *);
  void erase(void);
  void blit(void);
  void getPosition(float *, float *);
};

#endif /* _GLASS_H */
