/*
	TuxPuck - menu.h
	Copyright (C) 2001 Jacob Kroon

	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

	Jacob Kroon - d00jkr@efd.lth.se
*/

#ifndef _MENU_H
#define _MENU_H

class Menu;
class GameMenu;
class OpponentMenu;
class IngameMenu;
class SettingsMenu;

/* defines */
#define GAMEMENU_START_GAME	0
#define GAMEMENU_QUIT		1
#define INGAMEMENU_CONTINUE	0
#define INGAMEMENU_EXIT_GAME	1
#define OPPONENTMENU_TUX	0
#define OPPONENTMENU_CARTMAN	1
#define OPPONENTMENU_HOMER	2
#define OPPONENTMENU_CANCEL	4

/* includes */
#ifndef _FONT_H
#include "font.h"
#endif

/* class */
class Menu
{
private:
  Uint8 _nbrOfLabels;
  char **_label;
  Font *_font;
  void _drawLabel(Uint8, SDL_Rect *);
protected:
    Uint16 _w, _h;
public:
    Menu(Font *, Uint8);
    virtual ~ Menu();
  Uint8 getCommand(void);
  void addLabel(Uint8, char *);
  virtual void blitSectionBar(void) = 0;
};

class GameMenu:public Menu
{
private:
  SDL_Surface * _sdlLogo;
  Font *_fntVersion;
public:
    GameMenu(Font *, Font *);
   ~GameMenu();
  void blitSectionBar(void);
};

class IngameMenu:public Menu
{
private:
public:
  IngameMenu(Font *);
  ~IngameMenu();
  void blitSectionBar(void);
};

class SettingsMenu:public Menu
{
private:
public:
  SettingsMenu(Font *);
  ~SettingsMenu();
  void blitSectionBar(void);
};

class OpponentMenu:public Menu
{
private:
  SDL_Surface * _sdlOpponent;
public:
  OpponentMenu(Font *);
  ~OpponentMenu();
  void blitSectionBar(void);
};

#endif /* _MENU_H */
