/*
	TuxPuck - scoreboard.h
	Copyright (C) 2001 Jacob Kroon

	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

	Jacob Kroon - d00jkr@efd.lth.se
*/

#ifndef _SCOREBOARD_H
#define _SCOREBOARD_H

class Scoreboard;
class Arm;

/* includes */
#ifndef _SDL_video_h
#include <SDL_video.h>
#endif

/* class */
class Arm
{
private:
  Uint8 _state;
  Uint32 _x, _y;
  SDL_Surface *_sdlArm;
public:
    Arm();
   ~Arm();
};

class Scoreboard
{
private:
  Uint8 _score[2], _state;
  Arm *_arm;
  SDL_Surface *_sdlScoreboard;
public:
    Scoreboard();
   ~Scoreboard();
  void blit(void);
  void reblit(void);
  void update(Uint32);
  void addPoint(Uint8);
};

#endif /* _SCOREBOARD_H */
