/*
	TuxPuck - sprite.h
	Copyright (C) 2001 Jacob Kroon

	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

	Jacob Kroon - d00jkr@efd.lth.se
*/

#ifndef _SPRITE_H
#define _SPRITE_H

class Sprite;
class Animation;

/* includes */
#ifndef _SDL_video_h
#include <SDL_video.h>
#endif

/* class */
class Animation
{
private:
  Uint8 _nbrOfFrames, _currentFrame;
  Uint8 *_frame;
  Uint16 *_time;
  Uint32 _timeStamp;
public:
    Animation(Uint8 *, Uint32 *);
   ~Animation();
  Uint8 getFrame(void);
  Uint8 update(Uint32);
  void animate(Uint32);
  void reset(void);
};

class Sprite
{
private:
  Uint8 _nbrOfFrames, _nbrOfAnimations, _currentAnimation;
  Uint32 _x, _y;
  SDL_Rect _oldRect;
  SDL_Surface **_sdlFrame;
  Animation **_animation;
public:
    Sprite(Uint8 *, Uint32 *);
   ~Sprite();
  void setAnimation(Uint8);
  Uint8 getAnimation(void);
  Uint8 update(Uint32);
  void setPosition(Uint32, Uint32);
  void blit(void);
  void erase(void);
};

#endif /* _SPRITE_H */
