/*
	TuxPuck - tuxpuck.h
	Copyright (C) 2001 Jacob Kroon

	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

	Jacob Kroon - d00jkr@efd.lth.se
*/

#ifndef _TUXPUCK_H
#define _TUXPUCK_H

class TuxPuck;
struct Settings;

/* includes */
#ifndef _MENU_H
#include "menu.h"
#endif

/* class */
class TuxPuck
{
private:
  Font * _fntMenu, *_fntFps;
  GameMenu *_gameMenu;
  OpponentMenu *_opponentMenu;
  Settings *_settings;
#ifndef windows
  char _settingsFile[100];
#endif
  void _playMatch(Uint8);
  void _readSettings(void);
  void _saveSettings(void);
public:
    TuxPuck();
   ~TuxPuck();
  void start(void);
};

struct Settings
{
  Uint8 sound;
  Uint8 fullscreen;
  Uint8 transparency;
  Uint8 mouseSpeed;
  Uint8 showFps;
};

#endif /* _TUXPUCK_H */
