/*
	TuxPuck - video.h
	Copyright (C) 2001 Jacob Kroon

	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

	Jacob Kroon - d00jkr@efd.lth.se
*/

#ifndef _VIDEO_H
#define _VIDEO_H

class Video;

/* includes */
#ifndef _SDL_video_h
#include <SDL_video.h>
#endif

/* class */
class Video
{
private:
  static Video *_instance;
  SDL_Surface *_screen, *_background;
  SDL_Rect *_dirtyRect;
  Uint32 _noDirtyRects;
    Video();
public:
   ~Video();
  SDL_Surface *createSurface(Uint8 *, Uint32 *);
  SDL_Surface *scaleSurface(SDL_Surface *, float);
  SDL_Surface *duplicate(void);
  void blit(SDL_Surface *, SDL_Rect *);
  void fill(Uint32, SDL_Rect *);
  void blend(Uint8, SDL_Rect *);
  void erase(SDL_Rect *);
  void erase(SDL_Surface *, SDL_Rect *);
  void save(void);
  void update(void);
  void restore(void);
  void toggleFullscreen(void);
  static Video *instance(void);
};

#endif /* _VIDEO_H */
